<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="位置" prop="position">
        <el-input
          v-model="queryParams.position"
          placeholder="请输入位置"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="月份" prop="month">
        <el-date-picker
          v-model="month"
          :clearable="false"
          format="MM"
          placeholder="选择月"
          popper-class="picker-date"
          type="month"
          @change="handleQuery">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="年度" prop="year">
        <el-date-picker
          v-model="year"
          :clearable="false"
          format="yyyy"
          placeholder="请选择年份"
          type="year"
          @change="handleQuery">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="计划名称" prop="planId">
        <el-select v-model="queryParams.planId" clearable
                   @change="handleQuery">
          <el-option v-for="item in planList"
                     :key="item.id"
                     :label="item.planName"
                     :value="item.id"/>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['fire:aidkit:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['fire:aidkit:export']"
          icon="el-icon-download"
          plain
          size="mini"
          type="warning"
          @click="handleExport"
        >导出
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="aidkitList" @selection-change="handleSelectionChange" :height="clientHeight"
              border>
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="位置" align="center" prop="position" :show-overflow-tooltip="true"/>
      <el-table-column label="急救箱外观" align="center" prop="aidkitAppearance" :show-overflow-tooltip="true"/>
      <el-table-column label="内部物品是否按要求检查" align="center" prop="requireCheck" :show-overflow-tooltip="true"/>
      <el-table-column label="封条是否完整" align="center" prop="sealIntegrity" :show-overflow-tooltip="true"/>
      <el-table-column label="操作" align="center" fixed="right" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['fire:aidkit:edit']"
          >修改
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改急救箱检查记录对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="170px">
        <el-form-item label="急救箱外观" prop="aidkitAppearance">
          <el-radio v-model="form.aidkitAppearance" label="✔" border>✔</el-radio>
          <el-radio v-model="form.aidkitAppearance" label="✖" border>✖</el-radio>
        </el-form-item>
        <el-form-item label="内部物品是否按要求检查" prop="requireCheck">
          <el-radio v-model="form.requireCheck" label="✔" border>✔</el-radio>
          <el-radio v-model="form.requireCheck" label="✖" border>✖</el-radio>
        </el-form-item>
        <el-form-item label="封条是否完整" prop="sealIntegrity">
          <el-radio v-model="form.sealIntegrity" label="✔" border>✔</el-radio>
          <el-radio v-model="form.sealIntegrity" label="✖" border>✖</el-radio>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 用户导入对话框 -->
    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url + '?updateSupport=' + upload.updateSupport"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          将文件拖到此处，或
          <em>点击上传</em>
        </div>
        <div class="el-upload__tip" slot="tip">
          <el-checkbox v-model="upload.updateSupport"/>
          是否更新已经存在的用户数据
          <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
        </div>
        <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  addAidkit,
  delAidkit,
  exportAidkit,
  getAidkit,
  importTemplate,
  listAidkit,
  updateAidkit
} from "@/api/patrol/fire/aidkit";
import {treeselect} from "@/api/system/dept";
import {getToken} from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {listAllPlan} from "@/api/patrol/patrol/plan";

export default {
  name: "Aidkit",
  components: {Treeselect},
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 急救箱检查记录表格数据
      aidkitList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight: 300,
      // 是否显示弹出层
      open: false,
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/fire/aidkit/importData"
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        position: null,
        aidkitAppearance: null,
        requireCheck: null,
        sealIntegrity: null,
        confirmed: null,
        checkStatus: null,
        checkDate: null,
        month: null,
        year: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        remarks: null,
        deptId: null,
        planId: null,
        problemFileUrl: null,
        fileUrl: null,
        issuesStatus: null,
        issuesFlag: null,
        repairFile: null
      },
      month: new Date(),
      year: new Date(),
      planList: [],
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        delFlag: [
          {required: true, message: "删除标识0未删除不能为空", trigger: "blur"}
        ],
      }
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    console.log(this.$route.query)
    if (this.$route.query.year && this.$route.query.month) {
      this.year.setFullYear(this.$route.query.year, this.$route.query.month, 1);
      this.month.setMonth(this.$route.query.month, 1);
    }
    if (this.$route.query.planId) {
      this.queryParams.planId = parseInt(this.$route.query.planId)
    }
    if (this.$route.query.id) {
      this.queryParams.id = parseInt(this.$route.query.id)
      this.queryParams.issuesFlag = '1';
    }
    console.log(this.queryParams.planId)
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight - 250
    })
    this.getTreeselect();
    if (!this.queryParams.id) {
      let query = {planQuarter: this.month.getMonth() + 1, planYear: this.year.getFullYear(), patrolType: '27'}
      listAllPlan(query).then(res => {
        this.planList = res.data;
        if (res.data.length > 0) {
          this.queryParams.planId = res.data[0].id;
        }
        this.getList();
      })
    } else {
      this.getList();
    }
  },
  methods: {
    /** 查询急救箱检查记录列表 */
    getList() {
      this.loading = true;
      if (!this.queryParams.id) {
        this.queryParams.month = this.month.getMonth() + 1;
        this.queryParams.year = this.year.getFullYear();
      }
      listAidkit(this.queryParams).then(response => {
        this.aidkitList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    getPlanList() {
      let query = {planQuarter: this.month.getMonth() + 1, planYear: this.year.getFullYear(), patrolType: '27'}
      listAllPlan(query).then(res => {
        this.planList = res.data;
      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        position: null,
        aidkitAppearance: null,
        requireCheck: null,
        sealIntegrity: null,
        confirmed: null,
        checkStatus: "0",
        checkDate: null,
        month: null,
        year: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        remarks: null,
        deptId: null,
        planId: null,
        problemFileUrl: null,
        fileUrl: null,
        issuesStatus: "0",
        issuesFlag: null,
        repairFile: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
      this.getPlanList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加急救箱检查记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getAidkit(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改急救箱检查记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateAidkit(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addAidkit(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delAidkit(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有急救箱检查记录数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return exportAidkit(queryParams);
      }).then(response => {
        this.download(response.msg);
      })
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "用户导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      importTemplate().then(response => {
        this.download(response.msg);
      });
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", {dangerouslyUseHTMLString: true});
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    }
  }
};
</script>
